Index: trunk/MagicSoft/Mars/msignal/cosmics_weights.dat
===================================================================
--- trunk/MagicSoft/Mars/msignal/cosmics_weights.dat	(revision 5397)
+++ trunk/MagicSoft/Mars/msignal/cosmics_weights.dat	(revision 5400)
@@ -63,62 +63,63 @@
 # Low Gain Weights: 6 10
 # (Amplitude)  (Time) 
-	0.190173	-0.352992
-	0.155921	-0.475234
-	0.111158	-0.510688
-	0.0258716	-0.585781
-	-0.0846783	-0.752984
-	-0.259831	-1.02767
-	-0.439926	-1.02041
-	-0.585558	-0.734472
-	-0.663611	-0.690174
-	-0.73984	-0.576795
-	-0.672748	-0.173961
-	-0.693405	-0.0130429
-	-0.699736	0.1524
-	-0.698901	0.407909
-	-0.638204	0.836755
-	-0.44419	1.55279
-	-0.142557	1.8777
-	0.153996	1.59209
-	0.356156	1.7666
-	0.564031	1.65896
-	0.707804	1.38728
-	0.85022	1.45257
-	0.99052	1.2707
-	1.22473	1.15456
-	1.46489	1.05566
-	1.70603	0.973196
-	1.857	0.57388
-	1.8993	0.113422
-	1.88339	-0.2337
-	1.83839	-0.429011
-	1.78206	-0.626315
-	1.71376	-0.903836
-	1.61136	-1.05343
-	1.41208	-1.25025
-	1.14602	-1.52358
-	0.805571	-1.90971
-	0.502163	-1.71115
-	0.294872	-1.13556
-	0.189728	-1.07744
-	0.084943	-0.887703
-	-0.0316251	-0.719687
-	-0.109198	-0.668266
-	-0.185341	-0.531971
-	-0.300562	-0.397775
-	-0.390757	-0.259113
-	-0.449349	-0.0664538
-	-0.438326	0.189747
-	-0.387571	0.299769
-	-0.33554	0.456087
-	-0.272877	0.508469
-	-0.0686699	0.350793
-	-0.0289917	0.38007
-	0.0150257	0.319358
-	0.0807497	0.267639
-	0.144026	0.199999
-	0.187235	0.0767841
-	0.183333	-0.124801
-	0.139438	-0.239748
-	0.0952476	-0.3751
-	0.0410329	-0.38942
+-0.0851354 -0.0818943
+-0.121924 -0.584977
+-0.269186 -0.874395
+-0.470451 -1.00063
+-0.662756 -1.12938
+-0.770093 -1.10388
+-0.835339 -0.995019
+-0.899395 -0.884381
+-0.983397 -0.628212
+-0.997415 -0.00715026
+-1.11376 -0.0168757
+-1.0091 1.14057
+-0.638545 2.07741
+-0.107314 2.54285
+0.380996 3.02362
+0.731444 3.34887
+0.959498 3.28988
+1.17934 3.38254
+1.57619 4.01168
+1.8263 4.58323
+2.07564 5.08144
+2.53926 3.80961
+2.86297 2.12543
+2.91748 0.749097
+2.80503 -0.228309
+2.6423 -1.05946
+2.50982 -1.64579
+2.36653 -2.27444
+2.05553 -3.101
+1.87853 -3.72935
+2.03964 -4.75531
+1.43034 -4.09923
+0.877873 -2.95319
+0.551859 -1.99114
+0.451674 -1.45197
+0.44424 -1.0055
+0.467447 -0.55123
+0.471455 -0.160571
+0.48432 -0.250935
+0.432957 -0.747835
+-0.195425 0.688031
+-0.128512 0.426902
+-0.0250589 0.67848
+0.111442 0.594296
+0.137021 0.454404
+0.18465 0.425805
+0.173857 0.191566
+0.166493 -0.088923
+0.129184 -0.103965
+0.150974 0.0291908
+0.43261 -0.441491
+0.385866 -0.245876
+0.281277 -0.66199
+0.148729 -0.538564
+0.153182 -0.382713
+0.106348 -0.355415
+0.123019 -0.263842
+0.0911191 -0.197345
+0.0963107 -0.229423
+0.0550985 -0.187527
+
Index: trunk/MagicSoft/Mars/msignal/cosmics_weights4.dat
===================================================================
--- trunk/MagicSoft/Mars/msignal/cosmics_weights4.dat	(revision 5397)
+++ trunk/MagicSoft/Mars/msignal/cosmics_weights4.dat	(revision 5400)
@@ -43,42 +43,43 @@
 # Low Gain Weights: 4 10
 # (Amplitude)  (Time) 
--0.461712  -0.478171
--0.508663  -0.456735
--0.550858  -0.358047
--0.615084  -0.230953
--0.655615  0.0171828
--0.593359  0.573597
--0.354573  1.15547
--0.0166319  1.26005
-0.226452  1.52102
-0.451298  1.45511
-0.527201  1.27282
-0.680384  1.38144
-0.826361  1.26079
-1.05602  1.22515
-1.30687  1.29254
-1.59171  1.40908
-1.77973  0.952821
-1.79484  0.245375
-1.7262  -0.21442
-1.62411  -0.484694
-1.73426  -0.615484
-1.64165  -0.907105
-1.52898  -1.07112
-1.30084  -1.29905
-0.983446  -1.68008
-0.532795  -2.19838
-0.133827  -1.90033
--0.0392906  -1.02741
--0.0357089  -0.721406
--0.0139902  -0.385772
--0.414459  -0.200187
--0.406329  -0.0821537
--0.403955  0.0227461
--0.391219  0.127372
--0.347919  0.206207
--0.29191  0.277449
--0.234367  0.24775
--0.228396  0.104672
--0.238849  0.0733048
--0.245189  0.0500998	
+-0.990564 0.813232
+-0.806484 1.74836
+-0.43829 2.4249
+0.0451181 2.67058
+0.463887 3.01401
+0.714 3.23898
+0.887111 3.15779
+1.05327 3.24712
+1.32499 3.86809
+1.44213 4.59276
+2.06205 4.04486
+2.45161 2.90439
+2.6494 1.52572
+2.66069 0.436417
+2.55694 -0.362778
+2.43585 -1.04956
+2.34313 -1.55472
+2.24881 -2.11859
+2.03605 -2.86169
+1.95231 -3.51744
+1.6486 -3.72459
+1.2416 -3.07972
+0.925084 -2.32165
+0.684032 -1.68812
+0.589887 -1.32468
+0.570156 -1.05064
+0.561215 -0.620602
+0.551184 -0.200923
+0.562483 -0.388106
+0.561862 -1.06923
+0.511264 -0.720139
+0.418279 -0.712441
+0.378939 -0.269248
+0.425153 0.0483749
+0.467989 0.158911
+0.512818 0.306459
+0.533694 0.107538
+0.515955 -0.211784
+0.483112 -0.217814
+0.463744 0.0214888
+